Loading...
Searching...
No Matches
juce::AudioProcessor::Bus Class Reference

## Detailed Description

Describes the layout and properties of an audio bus.

Effectively a bus description is a named set of channel types.

See also
  AudioChannelSet, AudioProcessor::addBus

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/processors/juce_AudioProcessor.h

## Public Member Functions

bool | isInput () const noexcept
| Returns true if this bus is an input bus.
int | getBusIndex () const noexcept
| Returns the index of this bus.
bool | isMain () const noexcept
| Returns true if the current bus is the main input or output bus.
const String & | getName () const noexcept
| The bus's name.
const AudioChannelSet & | getDefaultLayout () const noexcept
| Get the default layout of this bus.
const AudioChannelSet & | getCurrentLayout () const noexcept
| The bus's current layout.
const AudioChannelSet & | getLastEnabledLayout () const noexcept
| Return the bus's last active channel layout.
bool | setCurrentLayout (const AudioChannelSet &layout)
| Sets the bus's current layout.
bool | setCurrentLayoutWithoutEnabling (const AudioChannelSet &layout)
| Sets the bus's current layout without changing the enabled state.
int | getNumberOfChannels () const noexcept
| Return the number of channels of the current bus.
bool | setNumberOfChannels (int channels)
| Set the number of channels of this bus.
bool | isLayoutSupported (const AudioChannelSet &set, BusesLayout *currentLayout=nullptr) const
| Checks if a particular layout is supported.
bool | isNumberOfChannelsSupported (int channels) const
| Checks if this bus can support a given number of channels.
AudioChannelSet | supportedLayoutWithChannels (int channels) const
| Returns a ChannelSet that the bus supports with a given number of channels.
int | getMaxSupportedChannels (int limit=AudioChannelSet::maxChannelsOfNamedLayout) const
| Returns the maximum number of channels that this bus can support.
BusesLayout | getBusesLayoutForLayoutChangeOfBus (const AudioChannelSet &set) const
| Returns the resulting layouts of all buses after changing the layout of this bus.
bool | isEnabled () const noexcept
| Returns true if the current bus is enabled.
bool | enable (bool shouldEnable=true)
| Enable or disable this bus.
bool | isEnabledByDefault () const noexcept
| Returns if this bus is enabled by default.
int | getChannelIndexInProcessBlockBuffer (int channelIndex) const noexcept
| Returns the position of a bus's channels within the processBlock buffer.
template<typename FloatType>
AudioBuffer< FloatType > | getBusBuffer (AudioBuffer< FloatType > &processBlockBuffer) const
| Returns an AudioBuffer containing a set of channel pointers for a specific bus.

## Member Functions

## isInput()

bool juce::AudioProcessor::Bus::isInput | ( |  | ) | const

noexcept

Returns true if this bus is an input bus.

Referenced by AudioProcessor.

## getBusIndex()

int juce::AudioProcessor::Bus::getBusIndex | ( |  | ) | const

noexcept

Returns the index of this bus.

References getBusIndex().

Referenced by getBusIndex(), and isMain().

## isMain()

bool juce::AudioProcessor::Bus::isMain | ( |  | ) | const

inline noexcept

Returns true if the current bus is the main input or output bus.

References getBusIndex(), and isMain().

Referenced by isMain().

## getName()

const String & juce::AudioProcessor::Bus::getName | ( |  | ) | const

inline noexcept

The bus's name.

## getDefaultLayout()

const AudioChannelSet & juce::AudioProcessor::Bus::getDefaultLayout | ( |  | ) | const

inline noexcept

Get the default layout of this bus.

See also
  AudioChannelSet

## getCurrentLayout()

const AudioChannelSet & juce::AudioProcessor::Bus::getCurrentLayout | ( |  | ) | const

inline noexcept

The bus's current layout.

This will be AudioChannelSet::disabled() if the current layout is disabled.

See also
  AudioChannelSet

## getLastEnabledLayout()

const AudioChannelSet & juce::AudioProcessor::Bus::getLastEnabledLayout | ( |  | ) | const

inline noexcept

Return the bus's last active channel layout.

If the bus is currently enabled then the result will be identical to getCurrentLayout otherwise it will return the last enabled layout.

See also
  AudioChannelSet

## setCurrentLayout()

bool juce::AudioProcessor::Bus::setCurrentLayout | ( | const AudioChannelSet & | layout | ) |

Sets the bus's current layout.

If the AudioProcessor does not support this layout then this will return false.

See also
  AudioChannelSet

## setCurrentLayoutWithoutEnabling()

bool juce::AudioProcessor::Bus::setCurrentLayoutWithoutEnabling | ( | const AudioChannelSet & | layout | ) |

Sets the bus's current layout without changing the enabled state.

If the AudioProcessor does not support this layout then this will return false.

See also
  AudioChannelSet

## getNumberOfChannels()

int juce::AudioProcessor::Bus::getNumberOfChannels | ( |  | ) | const

inline noexcept

Return the number of channels of the current bus.

## setNumberOfChannels()

bool juce::AudioProcessor::Bus::setNumberOfChannels | ( | int | channels | ) |

Set the number of channels of this bus.

This will return false if the AudioProcessor does not support this layout.

## isLayoutSupported()

bool juce::AudioProcessor::Bus::isLayoutSupported | ( | const AudioChannelSet & | set,
|  | BusesLayout * | currentLayout = nullptr ) const

Checks if a particular layout is supported.

Parameters

  set | The AudioChannelSet which is to be probed.
  currentLayout | If non-null, pretend that the current layout of the AudioProcessor is currentLayout. On exit, currentLayout will be modified to represent the buses layouts of the AudioProcessor as if the layout of the receiver had been successfully changed. This is useful as changing the layout of the receiver may change the bus layout of other buses.

See also
  AudioChannelSet

## isNumberOfChannelsSupported()

bool juce::AudioProcessor::Bus::isNumberOfChannelsSupported | ( | int | channels | ) | const

Checks if this bus can support a given number of channels.

## supportedLayoutWithChannels()

AudioChannelSet juce::AudioProcessor::Bus::supportedLayoutWithChannels | ( | int | channels | ) | const

Returns a ChannelSet that the bus supports with a given number of channels.

## getMaxSupportedChannels()

int juce::AudioProcessor::Bus::getMaxSupportedChannels | ( | int | limit = AudioChannelSet::maxChannelsOfNamedLayout | ) | const

Returns the maximum number of channels that this bus can support.

Parameters

  limit | The maximum value to return.

References juce::AudioChannelSet::maxChannelsOfNamedLayout.

## getBusesLayoutForLayoutChangeOfBus()

BusesLayout juce::AudioProcessor::Bus::getBusesLayoutForLayoutChangeOfBus | ( | const AudioChannelSet & | set | ) | const

Returns the resulting layouts of all buses after changing the layout of this bus.

Changing an individual layout of a bus may also change the layout of all the other buses. This method returns what the layouts of all the buses of the audio processor would be, if you were to change the layout of this bus to the given layout. If there is no way to support the given layout then this method will return the next best layout.

## isEnabled()

bool juce::AudioProcessor::Bus::isEnabled | ( |  | ) | const

inline noexcept

Returns true if the current bus is enabled.

## enable()

bool juce::AudioProcessor::Bus::enable | ( | bool | shouldEnable = true | ) |

Enable or disable this bus.

This will return false if the AudioProcessor does not support disabling this bus.

## isEnabledByDefault()

bool juce::AudioProcessor::Bus::isEnabledByDefault | ( |  | ) | const

inline noexcept

Returns if this bus is enabled by default.

## getChannelIndexInProcessBlockBuffer()

int juce::AudioProcessor::Bus::getChannelIndexInProcessBlockBuffer | ( | int | channelIndex | ) | const

noexcept

Returns the position of a bus's channels within the processBlock buffer.

This can be called in processBlock to figure out which channel of the master AudioBuffer maps onto a specific bus's channel.

## getBusBuffer()

template<typename FloatType>

AudioBuffer< FloatType > juce::AudioProcessor::Bus::getBusBuffer | ( | AudioBuffer< FloatType > & | processBlockBuffer | ) | const

inline

Returns an AudioBuffer containing a set of channel pointers for a specific bus.

This can be called in processBlock to get a buffer containing a sub-group of the master AudioBuffer which contains all the plugin channels.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited